/********************************************************************
 *
 ********************************************************************
 */
#include "common.h"
#include "cpu_config.h"
#include "hw_support.h"
#include "led.h"
#include "dbg_print.h"
#include "../debug.h"

#include "core_cm3.h"

/* low layer USB function driver disconnect request */
extern uint8_t USBF_UnAttach(void);

void SetSoftwareResetVector(int *vect);

void usbModuleDisable(void)
{
	/* low layer USB function driver disconnect request */
	USBF_UnAttach();

#if	0
    /* USB function reset */
	REG_W(bFM3_USB0_UDCC_RST,1);	// USB function core RESET (=1)

    /* wait for 3 cycle */
    __NOP();
    __NOP();
    __NOP();
    __NOP();
    __NOP();
    __NOP();
#endif
}









/********************************************************************
 *	( ms ) * 1mS ҂.
 ********************************************************************
 */
void wait_ms(int ms)
{
	int i;
	for(i=0; i<ms; i++) {
		wait_125ns(1000*8);
	}
}

/********************************************************************
 *	( us ) * 1uS ҂.
 ********************************************************************
 */
void wait_us(int us)
{
	wait_125ns(us*8);
}
/********************************************************************
 *	( us * 1/8 ) uS ҂. clock=72MHzƉ.
 ********************************************************************
 8002186:	bf00      	nop
 8002188:	bf00      	nop
 800218a:	bf00      	nop
 800218c:	bf00      	nop
 800218e:	bf00      	nop
 8002190:	3301      	adds	r3, #1
 8002192:	4283      	cmp	r3, r0
 8002194:	dbf7      	blt.n	8002186 <wait_u8s+0x4>
 */
#ifdef	MARY
//clock=48MHzƉ.	œKIvVRpCςČv.
void wait_125ns(int ns)
{
	int i;
	for(i=0; i<ns; i++) {
		asm("nop");
	}
}
#else
//clock=144MHzƉ.	œKIvVRpCςČv.
void wait_125ns(int ns)
{
	int i;
	for(i=0; i<ns; i++) {
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
	}
}
#endif
/********************************************************************
 *	( ms ) * 1mS ҂.
 ********************************************************************
 */
void wait_0us(void)
{

}

#define	RAM_VECTOR	(int*) 0x1fff0000

//FM3̂.
void setupVectorTable(int vect)
{
	int *ram_vect = RAM_VECTOR;
	int *rom_vect = (int*) vect;

	SetSoftwareResetVector(rom_vect);

	__disable_irq();
//	__disable_fault_irq();
	wait_ms(500);			// 0.5b҂.

	int i;
	for(i=0;i<64;i++) {
		ram_vect[i]=rom_vect[i];
	}

	NVIC_SystemReset();		// Software Reset. (See RST_STR ZbgvWX^ .SRST)
							//		or bFM3_CRG_RST_STR_SRST
	//߂Ă܂.

#if	1	// ͂boot.

	int stk  = rom_vect[0];
	int adrs = rom_vect[1];

	void (*func)(void);
	func = (void (*)()) adrs;

	// X^bN|C^.
    __asm volatile ("MSR msp, %0\n\t" : : "r" (stk) );

	func();

#endif
}	
